//************************************************************************
// Program Name	: Read a Value and Subtract 1000
// Programmer	: Petros Panayi	Stud. ID: 000000
// Date  Modif.	: 1 Sep 2017
//************************************************************************
// Comments: Demostration of integer input and output using printf and scanf.
//				Input value is redused by 1000 before printed.
//************************************************************************
    .data
in_message_str: 	.string	"Plese Enter a Integer Value:"
scanf_str: 			.string	"%d"
out_message_str: 	.string	"The new value is: %d\n"
//************************************************************************	
	.text
	.global	main
main:

	stp	X29, X30, [sp, -32]!	//	First (!) move the stack pointer 32 bytes down (sp-32). 32= 2*16
								//  and then store double x29 and x30. 
								// (pre-index modes whih means apply the offset before accessing the memory)
	add	x29, sp, 0				//	Copy the value of stack pointer to Frame Pointer
	
	adrp	x0, in_message_str				// Load the address of in_message_str (C6.2.10 page 536)
	add		x0, x0, :lo12:in_message_str	// [gdb maintenance info sections]
	bl	printf								// Call Function printf
	
	add	x1, x29, 28				// Set the location to store the input value (fp+28)
	adrp	x0, scanf_str		// Load the address of scanf_Str
	add	x0, x0, :lo12:scanf_str
	bl	scanf					// Call Function scanf
	
	ldr	w1, [x29, 28]			// Load the read value in register w1
	
	sub W1, W1, #1000			// Subtract an immidiate to the input value 
	
	adrp	x0, out_message_str  // Load the address of scanf_Str
	add	x0, x0, :lo12:out_message_str
	bl	printf				     // Call Function printf
	
	ldp	x29, x30, [sp], 32		// Release the stack space
	ret							// Return to loading function
//************************************************************************
