//************************************************************************
// Program Name	: Read one Character at a time and print it on the Screen
// Programmer	: Petros Panayi	Stud. ID: 000000
// Date  Modif.	: 1 Sep 2017
//************************************************************************
// Comments: Read one Character at a time and print it on the Screen
//************************************************************************

    .data
message_str: .string	"Welcome to EPL221 and Have a nice Day !!!"
out_message_str_1: .string	"%c\t"
out_message_str_2: .string	"%d\t"
out_message_str_3: .string	"%p\n"
//************************************************************************	
	.text
	.global	main
main:

	stp	X29, X30, [sp, -32]!	//	First (!) move the stack pointer 32 bytes down (sp-32)
								//  and then store double x29 and x30. 
								// (pre-index modes whih means apply the offset before accessing the memory)
	add	x29, sp, 0				//	Copy the value of stack pointer to Frame Pointer
	
	adrp	x0, message_str		// Load the address of in_message_str (C6.2.10 page 536)
	add		x0, x0, :lo12:message_str	// [ gdb maintenance info sections]
	mov  	x19, x0						// X19 is the first callee-save register
loop:	
	ldrb	w1, [x19,#0]			// Load the first character from the message_str
	cbz 	w1, exit 				// Compare and branch if zero.
	adrp	x0, out_message_str_1  	// Load the address of out_message_str_1
	add	x0, x0, :lo12:out_message_str_1
	bl	printf				    	// Call Function printf

	ldrb	w1, [x19,#0]			// Load the first character from the message_str
	adrp	x0, out_message_str_2  	// Load the address of out_message_str_2
	add	x0, x0, :lo12:out_message_str_2
	bl	printf	
	
	ldrb	w1, [x19,#0]			// Load the first character from the message_str
	adrp	x0, out_message_str_3  	// Load the address of out_message_str_3
	add	x0, x0, :lo12:out_message_str_3
	bl	printf	
	add x19, x19, #1				// Move the pointer one byte down
	b loop
	
exit:	
	ldp	x29, x30, [sp], 32		// Release the stack space
	ret							// Return to loading function
//************************************************************************
